
import { icons } from '../../utilities/icons';
import { render_template } from '../../utilities/mustache';
import type { NamedLocation } from '../../storage/named-location';
import type { WeatherGovAlerts, WeatherGovForecast, WeatherGovForecastPeriod } from './interface';

export function render_forecast(location: NamedLocation, forecast: WeatherGovForecast, alerts: WeatherGovAlerts) {
	let forecast_today: WeatherGovForecastPeriod[];
	let forecast_future: WeatherGovForecastPeriod[];
	const forecast_days: WeatherGovForecastPeriod[] = [ ];
	const forecast_nights: WeatherGovForecastPeriod[] = [ ];

	if (forecast.periods[0].isDaytime) {
		forecast_today = forecast.periods.slice(0, 2);
		forecast_future = forecast.periods.slice(2);
	}

	else {
		forecast_today = forecast.periods.slice(0, 1);
		forecast_future = forecast.periods.slice(1);
	}

	for (const period of forecast_future) {
		if (period.isDaytime) {
			forecast_days.push(period);
		}

		else {
			forecast_nights.push(period);
		}
	}

	const view = {
		location,
		forecast_today,
		forecast_future,
		forecast_days,
		forecast_nights,
		icons,
		alerts: alerts['@graph'],
	};

	return render_template('weather.gov/forecast.html.mustache', view);
}
