
export function deep_merge<T>(host: T, donor: T) : T {
	for (const [key, value] of Object.entries(donor)) {
		if (value != null && host[key] != null && typeof value === 'object' && typeof host[key] === 'object') {
			deep_merge(host[key], value);
			continue;
		}

		host[key] = value;
	}

	return host;
}

export function deep_freeze<T>(obj: T) : Readonly<T> {
	for (const value of Object.values(obj)) {
		if (value == null) {
			continue;
		}

		else if (typeof value === 'object' || typeof value === 'function') {
			deep_freeze(value);
		}
	}

	return Object.freeze(obj);
}

export function deep_copy<T>(obj: T) : T {
	return structuredClone(obj);

	// try {
	// 	return structuredClone(obj);
	// }

	// catch (error) {
	// 	if (error instanceof ReferenceError) {
	// 		return JSON.parse(JSON.stringify(obj));
	// 	}
	// }
}
