
export type Func<T extends any = any> = (...args: any[]) => T;

export type Params<T extends Func> = T extends (...args: infer P) => any ? P : never;

export type FirstParam<T extends Func> = T extends (first: infer F, ...args: infer P) => any ? F : never;

export type NonFirstParams<T extends Func> = T extends (first: infer F, ...args: infer P) => any ? P : never;

export type UUID = `${string}-${string}-${string}-${string}-${string}`;

export type ISODate = `${number}-${number}-${number}`;

export type ISOTime = `${number}:${number}:${number}.${number}`;

export type ISOZoneOffset = 'Z' | `${'+' | '-' | ''}${number}:${number}`;

export type ISOTimestamp = `${ISODate}T${ISOTime}${ISOZoneOffset}`;

export type TimeShort = `${number}:${number}`;

export type LocalDateTime = `${ISODate} ${TimeShort}`;

export type Timezone = `${string}/${string}`;

export type Locale = `${string}-${string}`;

export type HttpURL = `http${'s' | ''}://${string}`;

export type HttpURLSchemeless = `//${string}`;

export type URN<T extends string = string> = `urn:${T}`;
